From 1f9d1bfd8cdad32758b01c30a8588585ef264a5a Mon Sep 17 00:00:00 2001
From: Pierre-Yves Chibon <pingou@pingoured.fr>
Date: Dec 21 2018 14:23:41 +0000
Subject: [PATCH 1/3] Port fedocal to python3


Signed-off-by: Pierre-Yves Chibon <pingou@pingoured.fr>

---

diff --git a/fedocal/__init__.py b/fedocal/__init__.py
index 4bfc535..579bf01 100644
--- a/fedocal/__init__.py
+++ b/fedocal/__init__.py
@@ -22,10 +22,7 @@
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301, USA.
 """
-
-# These two lines are needed to run on EL6
-__requires__ = ['SQLAlchemy >= 0.7', 'jinja2 >= 2.4']
-import pkg_resources
+from __future__ import unicode_literals, absolute_import, print_function
 
 __version__ = '0.16'
 
@@ -34,7 +31,6 @@ import logging
 import textwrap
 import os
 import urllib
-import urlparse
 from dateutil import parser
 from logging.handlers import SMTPHandler
 
@@ -42,14 +38,18 @@ import flask
 import bleach
 import jinja2
 import markdown
+import six
+import six.moves
 import vobject
 from dateutil.relativedelta import relativedelta
 from flask_fas_openid import FAS
 from flask_multistatic import MultiStaticFlask
 from functools import wraps
 from pytz import common_timezones
+from six.moves.urllib.parse import urlparse, urljoin
 from sqlalchemy.exc import SQLAlchemyError
 from werkzeug import secure_filename
+
 from fedocal.fedocal_babel import Babel
 from fedocal.fedocal_babel import gettext
 from fedocal.fedocal_babel import format_datetime
@@ -228,7 +228,7 @@ def format_time_spinner(time):
     """ Template filter returning for a given time only the hours and
     minutes.
     """
-    if isinstance(time, basestring):
+    if isinstance(time, six.string_types):
         return ':'.join(time.split(':')[:2])
     else:
         return time.strftime('%H:%M')
@@ -266,7 +266,7 @@ def is_admin():
         return False
 
     admins = APP.config['ADMIN_GROUP']
-    if isinstance(admins, basestring):
+    if isinstance(admins, six.string_types):
         admins = set([admins])
     else:  # pragma: no cover
         admins = set(admins)
@@ -337,7 +337,7 @@ def get_timezone():
 def chunks(item_list, chunks_size):
     """ Yield successive n-sized chunks from item_list.
     """
-    for i in xrange(0, len(item_list), chunks_size):
+    for i in six.moves.range(0, len(item_list), chunks_size):
         yield item_list[i: i + chunks_size]
 
 
@@ -345,9 +345,9 @@ def is_safe_url(target):
     """ Checks that the target url is safe and sending to the current
     website not some other malicious one.
     """
-    ref_url = urlparse.urlparse(flask.request.host_url)
-    test_url = urlparse.urlparse(
-        urlparse.urljoin(flask.request.host_url, target))
+    ref_url = urlparse(flask.request.host_url)
+    test_url = urlparse(
+        urljoin(flask.request.host_url, target))
     return test_url.scheme in ('http', 'https') and \
         ref_url.netloc == test_url.netloc
 
@@ -720,7 +720,7 @@ def auth_login():
         groups.update(cal.admin_groups)
         groups.update(cal.editor_groups)
 
-    if isinstance(APP.config['ADMIN_GROUP'], basestring):
+    if isinstance(APP.config['ADMIN_GROUP'], six.string_types):
         groups.update([APP.config['ADMIN_GROUP']])
     else:
         groups.update(APP.config['ADMIN_GROUP'])
@@ -1730,16 +1730,16 @@ def upload_calendar(calendar_name):
                       'file: "%s"',
                       flask.g.fas_user.username, ical_file.filename)
             LOG.exception(err)
-            flask.flash(err.message, 'error')
+            flask.flash("%s" % err, 'error')
             return flask.render_template(
                 'upload_calendar.html', form=form, calendar=calendarobj)
 
         try:
             fedocallib.add_vcal_file(
-                SESSION, calendarobj, ical_file, flask.g.fas_user, is_admin())
+                SESSION, calendarobj, ical_file.read(), flask.g.fas_user, is_admin())
             flask.flash(gettext('Calendar uploaded'))
         except FedocalException as err:  # pragma: no cover
-            flask.flash(err.message, 'error')
+            flask.flash("%s" % err, 'error')
             return flask.render_template(
                 'upload_calendar.html', form=form, calendar=calendarobj)
         except SQLAlchemyError as err:  # pragma: no cover
diff --git a/fedocal/api.py b/fedocal/api.py
index ea68f61..eeaf65f 100644
--- a/fedocal/api.py
+++ b/fedocal/api.py
@@ -22,18 +22,18 @@
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301, USA.
 """
+from __future__ import unicode_literals, absolute_import, print_function
 
 
 import datetime
-import flask
 import json
-
 from dateutil import parser
+
+import flask
 from sqlalchemy.exc import SQLAlchemyError
 
 import fedocal.fedocallib as fedocallib
 from fedocal.doc_utils import load_doc
-
 from fedocal import APP, SESSION, LOG
 from fedocal.fedocallib.model import Calendar
 
diff --git a/fedocal/default_config.py b/fedocal/default_config.py
index c0d9a09..eaea502 100644
--- a/fedocal/default_config.py
+++ b/fedocal/default_config.py
@@ -22,6 +22,7 @@
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301, USA.
 """
+from __future__ import unicode_literals, absolute_import
 
 import os
 
diff --git a/fedocal/doc_utils.py b/fedocal/doc_utils.py
index 3df72df..b4976a3 100644
--- a/fedocal/doc_utils.py
+++ b/fedocal/doc_utils.py
@@ -23,9 +23,12 @@
  MA 02110-1301, USA.
 """
 
+from __future__ import unicode_literals, absolute_import
+
 import docutils
 import docutils.examples
 import markupsafe
+import six
 
 
 def modify_rst(rst):
@@ -72,7 +75,9 @@ def modify_html(html):
 def load_doc(endpoint):
     """ Utility to load an RST file and turn it into fancy HTML. """
 
-    rst = unicode(endpoint.__doc__)
+    rst = endpoint.__doc__
+    if isinstance(rst, six.binary_type):
+        rst = rst.decode('utf-8')
 
     rst = modify_rst(rst)
 
diff --git a/fedocal/fedocal_babel.py b/fedocal/fedocal_babel.py
index 6c90380..3303464 100644
--- a/fedocal/fedocal_babel.py
+++ b/fedocal/fedocal_babel.py
@@ -24,6 +24,7 @@
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301, USA.
 """
+from __future__ import unicode_literals, absolute_import, print_function
 
 from babel import support
 
diff --git a/fedocal/fedocallib/__init__.py b/fedocal/fedocallib/__init__.py
index e28aae3..9f4f703 100644
--- a/fedocal/fedocallib/__init__.py
+++ b/fedocal/fedocallib/__init__.py
@@ -13,12 +13,10 @@ your option) any later version.
 See http://www.gnu.org/copyleft/gpl.html  for the full text of the
 license.
 """
+from __future__ import unicode_literals, absolute_import, print_function
 
 import copy
-import vobject
-import pytz
 import operator
-
 from datetime import datetime
 from datetime import date
 from datetime import time
@@ -27,6 +25,9 @@ from dateutil import zoneinfo
 from dateutil.relativedelta import relativedelta
 import dateutil.rrule as rrule
 
+import six
+import pytz
+import vobject
 from sqlalchemy import create_engine
 from sqlalchemy.exc import SQLAlchemyError
 from sqlalchemy.orm import sessionmaker
@@ -1183,6 +1184,9 @@ def add_vcal_file(session, calendar, stream, fas_user, admin=False):
         'EDT': 'US/Eastern',
     }
 
+    if isinstance(stream, six.binary_type):
+        stream = stream.decode('utf-8')
+
     meetings = vobject.readOne(stream)
     for meeting in meetings.components():
         if meeting.name == 'VTIMEZONE':
diff --git a/fedocal/fedocallib/dbaction.py b/fedocal/fedocallib/dbaction.py
index 931e7c9..0f73957 100644
--- a/fedocal/fedocallib/dbaction.py
+++ b/fedocal/fedocallib/dbaction.py
@@ -14,6 +14,7 @@ your option) any later version.
 See http://www.gnu.org/copyleft/gpl.html  for the full text of the
 license.
 """
+from __future__ import unicode_literals, absolute_import, print_function
 
 from datetime import date
 from fedocal.fedocallib import  model
diff --git a/fedocal/fedocallib/exceptions.py b/fedocal/fedocallib/exceptions.py
index d8cb0b6..fd6f962 100644
--- a/fedocal/fedocallib/exceptions.py
+++ b/fedocal/fedocallib/exceptions.py
@@ -13,6 +13,7 @@ your option) any later version.
 See http://www.gnu.org/copyleft/gpl.html  for the full text of the
 license.
 """
+from __future__ import unicode_literals, absolute_import, print_function
 
 
 # pylint: disable=R0903
diff --git a/fedocal/fedocallib/fedmsgshim.py b/fedocal/fedocallib/fedmsgshim.py
index 139765e..9729095 100644
--- a/fedocal/fedocallib/fedmsgshim.py
+++ b/fedocal/fedocallib/fedmsgshim.py
@@ -5,6 +5,7 @@ messages.  If it is not installed, it will return silently.
   :Author: Ralph Bean <rbean@redhat.com>
 
 """
+from __future__ import unicode_literals, absolute_import, print_function
 
 import warnings
 
diff --git a/fedocal/fedocallib/fedora_calendar.py b/fedocal/fedocallib/fedora_calendar.py
index e32a041..391f3b0 100644
--- a/fedocal/fedocallib/fedora_calendar.py
+++ b/fedocal/fedocallib/fedora_calendar.py
@@ -14,17 +14,22 @@ your option) any later version.
 See http://www.gnu.org/copyleft/gpl.html  for the full text of the
 license.
 """
+from __future__ import unicode_literals, absolute_import, print_function
 
-from datetime import date
-from calendar import LocaleHTMLCalendar
-from calendar import TimeEncoding
-from calendar import month_name
+import calendar
 import locale
-import fedocal
+from datetime import date
+try:
+    from calendar import TimeEncoding
+    PY3 = False
+except ImportError:
+    PY3 = True
+
 import flask
 
+import fedocal
 
-class FedocalCalendar(LocaleHTMLCalendar):
+class FedocalCalendar(calendar.LocaleHTMLCalendar):
     """ Improve Python's HTMLCalendar object adding
     html validation and some features 'locally required'
     """
@@ -112,15 +117,19 @@ class FedocalCalendar(LocaleHTMLCalendar):
         if self.locale in ['en', 'en_EN']:
             lcle = 'C'
 
-        with TimeEncoding(lcle) as encoding:
-            smonth = month_name[themonth]
-            if encoding is not None:
-                smonth = smonth.decode(encoding)
+        if PY3:
+            with calendar.different_locale(lcle) as encoding:
+                smonth = calendar.month_name[themonth].capitalize()
+        else:
+            with TimeEncoding(lcle) as encoding:
+                smonth = calendar.month_name[themonth].capitalize()
+                if encoding is not None:
+                    smonth = smonth.decode(encoding).capitalize()
 
-            if withyear:
-                string = '%s %s' % (smonth, theyear)
-            else:
-                string = '%s' % smonth
+        if withyear:
+            string = '%s %s' % (smonth, theyear)
+        else:
+            string = '%s' % smonth
 
         prev_month = self.month - 1
         prev_year = self.year
diff --git a/fedocal/fedocallib/model.py b/fedocal/fedocallib/model.py
index 73fda81..408666d 100644
--- a/fedocal/fedocallib/model.py
+++ b/fedocal/fedocallib/model.py
@@ -14,13 +14,14 @@ your option) any later version.
 See http://www.gnu.org/copyleft/gpl.html  for the full text of the
 license.
 """
-__requires__ = ['SQLAlchemy >= 0.7']
-import pkg_resources
+from __future__ import unicode_literals, absolute_import, print_function
+
 import operator
 
 from datetime import date
 from datetime import timedelta
 
+import six
 from sqlalchemy import (
     Boolean,
     create_engine,
@@ -411,7 +412,7 @@ class Meeting(BASE):
         if ',' in meeting_manager:
             meeting_manager = meeting_manager.split(',')
 
-        if isinstance(meeting_manager, basestring):
+        if isinstance(meeting_manager, six.string_types):
             meeting_manager = [meeting_manager]
 
         for manager in meeting_manager:
diff --git a/fedocal/fedocallib/week.py b/fedocal/fedocallib/week.py
index 27b06c4..80e8d0d 100644
--- a/fedocal/fedocallib/week.py
+++ b/fedocal/fedocallib/week.py
@@ -13,6 +13,7 @@ your option) any later version.
 See http://www.gnu.org/copyleft/gpl.html  for the full text of the
 license.
 """
+from __future__ import unicode_literals, absolute_import, print_function
 
 from datetime import timedelta
 import operator
diff --git a/fedocal/flask_multistatic.py b/fedocal/flask_multistatic.py
index 525e425..91254c0 100644
--- a/fedocal/flask_multistatic.py
+++ b/fedocal/flask_multistatic.py
@@ -23,6 +23,7 @@
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301, USA.
 """
+from __future__ import unicode_literals, absolute_import, print_function
 
 import os
 import sys
diff --git a/fedocal/i18nforms.py b/fedocal/i18nforms.py
index 03794d8..d52ef84 100644
--- a/fedocal/i18nforms.py
+++ b/fedocal/i18nforms.py
@@ -23,6 +23,7 @@
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
  MA 02110-1301, USA.
 """
+from __future__ import unicode_literals, absolute_import, print_function
 
 try:
    from flask_wtf import FlaskForm as FlaskForm
diff --git a/fedocal/mail_logging.py b/fedocal/mail_logging.py
index b162291..d243373 100644
--- a/fedocal/mail_logging.py
+++ b/fedocal/mail_logging.py
@@ -18,6 +18,7 @@
 # License and may only be used or replicated with the express permission
 # of Red Hat, Inc.
 #
+from __future__ import unicode_literals, absolute_import, print_function
 
 '''
 Mail handler for logging.
diff --git a/fedocal/proxy.py b/fedocal/proxy.py
index 33a1daa..89bc75d 100644
--- a/fedocal/proxy.py
+++ b/fedocal/proxy.py
@@ -18,6 +18,7 @@
 # License and may only be used or replicated with the express permission
 # of Red Hat, Inc.
 #
+from __future__ import unicode_literals, absolute_import, print_function
 
 '''
 Makes fedocal an application behind a reverse proxy and thus ensure the
diff --git a/tests/__init__.py b/tests/__init__.py
index 90ad14d..61d3089 100644
--- a/tests/__init__.py
+++ b/tests/__init__.py
@@ -26,20 +26,18 @@
 
  fedocal.model test script
 """
-from __future__ import print_function
-
-__requires__ = ['SQLAlchemy >= 0.7']
-import pkg_resources
+from __future__ import unicode_literals, absolute_import, print_function
 
 import unittest
 import sys
 import os
 
+from contextlib import contextmanager
 from datetime import date
 from datetime import timedelta
 from functools import wraps
 
-from contextlib import contextmanager
+import six
 from sqlalchemy import create_engine
 from sqlalchemy.orm import sessionmaker
 from sqlalchemy.orm import scoped_session
@@ -152,7 +150,7 @@ class FakeUser(object):
         :arg groups: list of the groups in which this fake user is
             supposed to be.
         """
-        if isinstance(groups, basestring):
+        if isinstance(groups, six.string_types):
             groups = [groups]
         self.groups = groups
         self.username = username
diff --git a/tests/test_calendar.py b/tests/test_calendar.py
index 204d18c..f7197c5 100644
--- a/tests/test_calendar.py
+++ b/tests/test_calendar.py
@@ -26,9 +26,7 @@
 
  fedocal.model test script
 """
-
-__requires__ = ['SQLAlchemy >= 0.7']
-import pkg_resources
+from __future__ import unicode_literals, absolute_import, print_function
 
 import unittest
 import sys
diff --git a/tests/test_cron.py b/tests/test_cron.py
index 059f2af..1c29df1 100644
--- a/tests/test_cron.py
+++ b/tests/test_cron.py
@@ -27,8 +27,7 @@
  tests for fedocal's cron job
 """
 
-__requires__ = ['SQLAlchemy >= 0.7', 'jinja2 >= 2.4']
-import pkg_resources
+from __future__ import unicode_literals, absolute_import, print_function
 
 import logging
 import unittest
@@ -49,8 +48,8 @@ from fedocal.fedocallib import week
 from fedocal.fedocallib import exceptions
 
 import tests
-from tests import Modeltests
-from test_meeting import Meetingtests, TODAY
+from . import Modeltests
+from .test_meeting import Meetingtests, TODAY
 
 
 DB_PATH = 'sqlite:////tmp/fedocal_test.sqlite'
diff --git a/tests/test_fedocallib.py b/tests/test_fedocallib.py
index 97229a6..d0001f4 100644
--- a/tests/test_fedocallib.py
+++ b/tests/test_fedocallib.py
@@ -26,9 +26,7 @@
 
  fedocal.model test script
 """
-
-__requires__ = ['SQLAlchemy >= 0.7', 'jinja2 >= 2.4']
-import pkg_resources
+from __future__ import unicode_literals, absolute_import, print_function
 
 import unittest
 import sys
@@ -62,7 +60,7 @@ class Fedocallibtests(Modeltests):
 
     def __setup_calendar(self):
         """ Set up basic calendar information. """
-        from test_calendar import Calendartests
+        from .test_calendar import Calendartests
         cal = Calendartests('test_init_calendar')
         cal.session = self.session
         cal.test_init_calendar()
@@ -70,7 +68,7 @@ class Fedocallibtests(Modeltests):
     def __setup_meeting(self):
         """ Set up basic calendar information and add some meetings in
         them. """
-        from test_meeting import Meetingtests
+        from .test_meeting import Meetingtests
         meeting = Meetingtests('test_init_meeting')
         meeting.session = self.session
         meeting.test_init_meeting()
diff --git a/tests/test_fedocallib_extras.py b/tests/test_fedocallib_extras.py
index 04f93f0..9c376cb 100644
--- a/tests/test_fedocallib_extras.py
+++ b/tests/test_fedocallib_extras.py
@@ -27,9 +27,7 @@
  fedocal.lib tests script
  - for special corner case to test
 """
-
-__requires__ = ['SQLAlchemy >= 0.7', 'jinja2 >= 2.4']
-import pkg_resources
+from __future__ import unicode_literals, absolute_import, print_function
 
 import unittest
 import sys
diff --git a/tests/test_fedora_calendar.py b/tests/test_fedora_calendar.py
index 74951f0..aa10e5c 100644
--- a/tests/test_fedora_calendar.py
+++ b/tests/test_fedora_calendar.py
@@ -26,9 +26,7 @@
 
  fedocal.model test script
 """
-
-__requires__ = ['SQLAlchemy >= 0.7', 'jinja2 >= 2.4']
-import pkg_resources
+from __future__ import unicode_literals, absolute_import, print_function
 
 import unittest
 import sys
